VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H80000004&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Arrow-maze"
   ClientHeight    =   3435
   ClientLeft      =   150
   ClientTop       =   840
   ClientWidth     =   3510
   Icon            =   "Labyrint 2.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   3510
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture2 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   3720
      Picture         =   "Labyrint 2.frx":0CCA
      ScaleHeight     =   615
      ScaleWidth      =   5160
      TabIndex        =   1
      Top             =   720
      Visible         =   0   'False
      Width           =   5160
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H80000008&
      Height          =   3100
      Left            =   120
      ScaleHeight     =   3075
      ScaleWidth      =   3225
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
   Begin VB.Line Line2 
      BorderColor     =   &H8000000E&
      X1              =   0
      X2              =   3600
      Y1              =   10
      Y2              =   10
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      X1              =   0
      X2              =   3600
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFil 
      Caption         =   "File"
      Begin VB.Menu mnuNew 
         Caption         =   "New game"
      End
      Begin VB.Menu mnuRestart 
         Caption         =   "Restart level"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAvslutt 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuHjelp 
      Caption         =   "Hjelp"
      Begin VB.Menu mnuHowspille 
         Caption         =   "How do i play this game?"
      End
      Begin VB.Menu mnuOm 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Retning
R As Single
L As Single
End Type

Dim penLevel As Integer
Dim O
Dim A As Retning
Dim MW As Integer, MH As Integer
Dim BWidth As Integer
Dim Brikker() As Integer

Sub Tegn()

Dim A, B

Picture1.Cls
Picture1.FillStyle = 0
Picture1.FillColor = RGB(255, 0, 0)

For A = 1 To O
For B = 1 To O
If Not Brikker(A, B) = 0 Then Picture1.PaintPicture Picture2.Picture, (A - 1) * BWidth, (B - 1) * Picture2.Height, BWidth, Picture2.Height, (Brikker(A, B) - 1) * BWidth, 0, BWidth, Picture2.Height, vbSrcCopy
If MW = A And MH = B Then Picture1.Circle ((A - 1) * BWidth + (BWidth / 2), (B - 1) * Picture2.Height + (Picture2.Height - 120)), 120, RGB(0, 0, 0)
Next
Next

End Sub

Private Sub Command1_Click()

LoadLevel 2

End Sub

Private Sub Form_Load()

penLevel = 1
LoadLevel 1

End Sub

Private Sub GetRetning(Retning As Retning, Number As Integer)

' The most easily way to rotate a object

Select Case Number
Case Is = 1
Retning.L = 1
Retning.R = 0
Case Is = 2
Retning.L = 0
Retning.R = -1
Case Is = 3
Retning.L = 0
Retning.R = 1
Case Is = 4
Retning.L = -1
Retning.R = 0
Case Is = 5
Retning.L = -1
Retning.R = -1
Case Is = 6
Retning.L = 1
Retning.R = -1
Case Is = 7
Retning.L = -1
Retning.R = 1
Case Is = 8
Retning.L = 1
Retning.R = 1
End Select

End Sub

Private Sub Form_Resize()

Line1.X2 = Form1.Width
Line2.X2 = Form1.Width

End Sub

Private Sub mnuAvslutt_Click()

End

End Sub

Private Sub mnuHowspille_Click()

Form2.Left = Form1.Left + Form1.Width
Form2.Top = Form1.Top + 265
Form2.Show

End Sub

Private Sub mnuNew_Click()

penLevel = 1
LoadLevel 1

End Sub

Private Sub mnuOm_Click()

MsgBox "This game was made by Kristian.S.Stangeland", vbInformation, "About"

End Sub

Private Sub mnuRestart_Click()

LoadLevel penLevel

End Sub

Private Sub Picture1_KeyDown(KeyCode As Integer, Shift As Integer)

If KeyCode = 13 Then Call GetRetning(A, Brikker(MW, MH))
If KeyCode = vbKeyControl Then
If MW = 1 And A.L = -1 Then Exit Sub
If MW = O And A.L = 1 Then Exit Sub
If MH = 1 And A.R = -1 Then Exit Sub
If MH = O And A.R = 1 Then Exit Sub
MW = MW + A.L
MH = MH + A.R
End If

Tegn

If Brikker(MW, MH) = 0 Then
penLevel = penLevel + 1
LoadLevel penLevel
End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

End

End Sub

Sub LoadLevel(Level As Integer)

Dim AA, B, C, X, SW, SH
On Error GoTo A
Open App.Path & "/" & "Level" & Level & ".dat" For Input As #1
Input #1, O
Input #1, SW
Input #1, SH
Line Input #1, C

ReDim Brikker(1 To O, 1 To O)

For AA = 1 To O
For B = 1 To O
X = X + 1
Brikker(B, AA) = Mid(C, X, 1)
Next
Next

Close #1

MW = SW
MH = SH

GetRetning A, Brikker(MW, MH)

BWidth = 43 * Screen.TwipsPerPixelX

Picture1.Width = (O * BWidth) + 35
Picture1.Height = (O * Picture2.Height) + 35

Form1.Width = Picture1.Width + 340
Form1.Height = Picture1.Height + 980

Tegn

Exit Sub
A:
MsgBox "Gratulerer, du har klart spillet", vbInformation, "Gratulerer"
End

End Sub
